"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = user;
const add_user_1 = __importDefault(require("../../actions/users/add-user"));
const get_user_1 = __importDefault(require("../../actions/users/get-user"));
const login_user_1 = __importDefault(require("../../actions/users/login-user"));
const logout_user_1 = __importDefault(require("../../actions/users/logout-user"));
const reset_password_1 = __importDefault(require("../../actions/users/reset-password"));
const send_email_code_1 = __importDefault(require("../../actions/users/send-email-code"));
const google_auth_1 = __importDefault(require("../../actions/users/social/google-auth"));
const update_user_1 = __importDefault(require("../../actions/users/update-user"));
const user_auth_1 = __importDefault(require("../../actions/users/user-auth"));
const validate_temp_email_code_1 = __importDefault(require("../../actions/users/validate-temp-email-code"));
function user(params) {
    return {
        auth: {
            login: (params === null || params === void 0 ? void 0 : params.local)
                ? (_) => __awaiter(this, void 0, void 0, function* () {
                    return yield (0, login_user_1.default)(Object.assign(Object.assign({}, _), { useLocal: true }));
                })
                : login_user_1.default,
            get: (params === null || params === void 0 ? void 0 : params.local)
                ? (_) => __awaiter(this, void 0, void 0, function* () {
                    return yield (0, get_user_1.default)(Object.assign(Object.assign({}, _), { useLocal: true }));
                })
                : get_user_1.default,
            signup: (params === null || params === void 0 ? void 0 : params.local)
                ? (_) => __awaiter(this, void 0, void 0, function* () {
                    return yield (0, add_user_1.default)(Object.assign(Object.assign({}, _), { useLocal: true }));
                })
                : add_user_1.default,
            sendEmailCode: (params === null || params === void 0 ? void 0 : params.local)
                ? (_) => __awaiter(this, void 0, void 0, function* () {
                    return yield (0, send_email_code_1.default)(Object.assign(Object.assign({}, _), { useLocal: true }));
                })
                : send_email_code_1.default,
            update: (params === null || params === void 0 ? void 0 : params.local)
                ? (_) => __awaiter(this, void 0, void 0, function* () {
                    return yield (0, update_user_1.default)(Object.assign(Object.assign({}, _), { useLocal: true }));
                })
                : update_user_1.default,
            resetPassword: (params === null || params === void 0 ? void 0 : params.local)
                ? (_) => __awaiter(this, void 0, void 0, function* () {
                    return yield (0, reset_password_1.default)(Object.assign(Object.assign({}, _), { useLocal: true }));
                })
                : reset_password_1.default,
            googleLogin: (params === null || params === void 0 ? void 0 : params.local)
                ? (_) => __awaiter(this, void 0, void 0, function* () {
                    return yield (0, google_auth_1.default)(Object.assign(Object.assign({}, _), { useLocal: true }));
                })
                : google_auth_1.default,
            logout: logout_user_1.default,
            auth: user_auth_1.default,
            validateTempEmailCode: validate_temp_email_code_1.default,
        },
    };
}
